package ims.coref.markables;

import ims.coref.data.Document;
import ims.coref.data.Sentence;
import ims.coref.data.Span;
import ims.coref.io.DocumentReader;

import java.util.Set;
import java.util.TreeSet;

public abstract class AbstractMarkableExtractor implements IMarkableExtractor {
	private static final long serialVersionUID = 1L;

	@Override
	public Set<Span> extractMarkables(Document d) {
		Set<Span> sink=new TreeSet<Span>();
		for(Sentence s:d.sen){
			extractMarkables(s,sink,d.docName);
		}
		return sink;
	}

	@Override
	public boolean needsTraining() {
		return false;
	}

	@Override
	public void train(DocumentReader reader) {
		throw new Error("you are wrong here");
	}

}
