package ims.coref.markables;

import ims.coref.data.CFGTree.Node;
import ims.coref.data.CFGTree.NonTerminal;
import ims.coref.data.Sentence;
import ims.coref.data.Span;

import java.util.Set;

public class NonTerminalExtractor extends AbstractMarkableExtractor{
	private static final long serialVersionUID = 1L;
	
	final String label;
	
	public NonTerminalExtractor(String label){
		this.label=label;
	}

	@Override
	public void extractMarkables(Sentence s, Set<Span> sink,String docName) {
		recurseAndAdd(s.ct.root,sink);
	}

	private void recurseAndAdd(Node cfgNode,Set<Span> sink){
		if(cfgNode instanceof NonTerminal){
			if(cfgNode.getLabel().equals(label)){
				sink.add(cfgNode.getSpan());
			}
			for(Node n:cfgNode.getChildren())
				recurseAndAdd(n,sink);
		}
	}
	
	public String toString(){
		return "NT-"+label;
	}
}
