package ims.coref.resolver;

import ims.coref.data.CorefSolution;
import ims.coref.data.Document;
import ims.coref.data.SpanListStruct;
import ims.coref.features.FeatureSet;
import ims.coref.markables.IMarkableExtractor;
import ims.coref.postprocessor.IChainPostProcessor;
import ims.ml.liblinear.LibLinearModel;

public class ClosestFirstResolver extends AbstractResolver{
	
	public ClosestFirstResolver(IMarkableExtractor me,LibLinearModel llModel, FeatureSet fs,IChainPostProcessor pp,int decodeWindow,SingleLinkConstraint slc) {
		super(me, llModel, fs, pp, decodeWindow,slc);
	}

	public CorefSolution doResolve(SpanListStruct sls,Document d) {
		CorefSolution solution=new CorefSolution();
		for(int anaIndex=1;anaIndex<sls.size();++anaIndex)
			resolveClosestFirst(sls, solution, anaIndex,d);
		return solution;
	}

	public String toString() {
		return this.getClass().getCanonicalName()+"  (SLC: "+slc+")";
	}
}
